#!/bin/bash
#
# userlist.cgi
#
# Copyright (C) 1998 Reiner Klaproth <klaproth@online.de>
# Reiner Klaproth, 29.06.2003: Anpassung an LDAP

export QUERY_STRING
eval `cgiparse -form`
HOST=`hostname`


cgiutils -ct text/html -cl de -expires now
cat << xxxEOF1xxx

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<HTML>
<HEAD>
   <TITLE>Nutzerliste</TITLE>
   <META NAME="Author" CONTENT="Reiner Klaproth">
</HEAD>
<BODY background="whttxtr2.jpg">
<A HREF="index.htm">
<IMG SRC="back.gif" BORDER=0 ALT="Pfeil">  Zur&uuml;ck</A>
<H1>Nutzer-&Uuml;bersicht</H1>
<HR>
<P>
xxxEOF1xxx

if [ -z "${FORM_user}" ]; then
        # Eine neue Liste aufbauen
	cat << xxxEOF2xxx
Bitte w&auml;hlen Sie die Gruppe aus der Liste aus! 
<P>
<UL>
  <LI><A HREF="userlist.cgi?user=ALLE">ALLE</A>
xxxEOF2xxx

	# Wir lesen nur die Eintraege aus dem LDAP, die ein Komma enthalten
	x=`ldapsearch -x -LLL "(&(objectClass=posixAccount)(gecos=*,*))" gecos | grep "gecos:" | awk -F: '{
	    klasse=$2
	    sub("[^,]*", "", klasse);
	    sub("^,[    ]*", "", klasse);
	    sub("[  ]*,.*", "", klasse);
	    print  klasse 
	    }' | egrep -v '^[ "]*$' | sort | uniq
	`
	for klasse in $x ; do
	   if [ ! -z "$klasse" ]; then
	   echo "<LI><A HREF=\"userlist.cgi?user=${klasse}\">${klasse}</A>"
	   fi
	done
	echo "</UL>"

else
    # Der Username ist angegeben. Wir werten das per Liste aus.
    # Zuerst einen sicheren Dateinamen erzeugen
    TMPFILE=`mktemp -q /var/apache/tmp/userlist.XXXXXX`
    if [ $? -ne 0 ];then
	echo "<BIG>Fehler beim Erzeugen der Liste!</BIG>"    
    else
	# Nun testen, ob die Angabe stimmt
	if `echo "${FORM_user}" | grep -q -E '[;/&|<>()\`*]' ` ; then
	    echo "<BIG>Falsche Angabe der Klasse</BIG></BODY></HTML>"
	    exit 0
	fi
	# Liste zusammenstellen in $TMPFILE
	if [ ${FORM_user} = "ALLE" ]; then
		ldapsearch -x -LLL "(&(objectClass=posixAccount)(gecos=*,*))" gecos >$TMPFILE
	    else
		ldapsearch -x -LLL "(&(objectClass=posixAccount)(gecos=*,${FORM_user}))" gecos >$TMPFILE
	fi
	# wenn die Liste leer ist, gibt es die Klasse nicht
	x=`cat $TMPFILE`
	if [ x"$x" = x ]; then
		echo "<BIG>Diese Klasse existiert nicht!</BIG></BODY></HTML>"
		exit 0
	fi
	# OK, wir erzeugen die Seite
	echo "Benutzer auf $HOST in "
	if [ "${FORM_user}" = "ALLE" ]; then
		echo "alphabetischer Reihenfolge: <P>"
	else
		echo "Klasse ${FORM_user} : <P>"
	fi
	cat << xxxEOF4xxx

<TABLE BORDER WIDTH=80%>
<TR>
  <TH WIDTH=15%> Kennung </TH>
  <TH WIDTH=30%> Name </TH>
  <TH WIDTH=15%> Klasse </TH>
  <TH> Homepage </TH>
</TR>
xxxEOF4xxx
	# Wir bauen die Liste von LDAPsearch um, damit wir die Parameter finden
	awk -F: '{
		if ( $1 == "dn" ) printf $2 ":" ;
		if ( $1 == "gecos" ) print $2 ;
		}' $TMPFILE | grep "uid=" | sort > $TMPFILE.tmp
	# Jetzt haben wir eine Liste in der Form
	# uid=mmax,ou=SCHUELER,o=SCHULE,dc=domain,c=de:Max Mueller,7a
	# Die werten wir nun noch mal aus, so dass nur bleibt
	# mmax,Max Mueller,7a
	echo -n "" > $TMPFILE
	while IFS=: read dn gecos ; do
		uid=`echo $dn | cut -d, -f1 | cut -d= -f2`
		echo "${uid},$gecos" >> $TMPFILE
	done < $TMPFILE.tmp
	rm -f $TMPFILE.tmp
	
	# Formatieren der Liste
	DOMAIN=`cut -d. -f2- /etc/HOSTNAME`
	awk -F, -v domain="$DOMAIN" -v host="$HOST" '{
		print "<TR><TD><A HREF=\"mailto:" $1 "@" domain "\"> " $1 \
	   "</A></TD><TD>" $2 "</TD><TD>" $3 \
	   "</TD><TD><A HREF=\"http://" host "/~" $1 "\"> http://" host "/~" $1 \
	   "</A></TD></TR>"
	}' $TMPFILE

	rm -f $TMPFILE

	echo "</TABLE>"
    fi
fi

cat << xxxEOFxxx
<P><HR>Letzte &Auml;nderung: 28.06.2003

<P>&copy; 
Reiner Klaproth

</BODY>
</HTML>
xxxEOFxxx

